/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.cosmodas.EntCosmos;

import java.io.Serializable;
import java.util.Collection;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 * @author obper
 */
@Entity
@Table(name = "ubicacion")
@XmlRootElement
@NamedQueries({
        @NamedQuery(name = "Ubicacion.findAll", query = "SELECT u FROM Ubicacion u"),
        @NamedQuery(name = "Ubicacion.findByUbicacionCodigo", query = "SELECT u FROM Ubicacion u WHERE u.ubicacionCodigo = :ubicacionCodigo"),
        @NamedQuery(name = "Ubicacion.findByUbicacionNombre", query = "SELECT u FROM Ubicacion u WHERE u.ubicacionNombre = :ubicacionNombre")})
public class Ubicacion implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 2)
    @Column(name = "ubicacion_codigo")
    private String ubicacionCodigo;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 15)
    @Column(name = "ubicacion_nombre")
    private String ubicacionNombre;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "ubicacionCodigo")
    private Collection<Consultores> consultoresCollection;

    public Ubicacion() {
    }

    public Ubicacion(String ubicacionCodigo) {
        this.ubicacionCodigo = ubicacionCodigo;
    }

    public Ubicacion(String ubicacionCodigo, String ubicacionNombre) {
        this.ubicacionCodigo = ubicacionCodigo;
        this.ubicacionNombre = ubicacionNombre;
    }

    public String getUbicacionCodigo() {
        return ubicacionCodigo;
    }

    public void setUbicacionCodigo(String ubicacionCodigo) {
        this.ubicacionCodigo = ubicacionCodigo;
    }

    public String getUbicacionNombre() {
        return ubicacionNombre;
    }

    public void setUbicacionNombre(String ubicacionNombre) {
        this.ubicacionNombre = ubicacionNombre;
    }

    @XmlTransient
    public Collection<Consultores> getConsultoresCollection() {
        return consultoresCollection;
    }

    public void setConsultoresCollection(Collection<Consultores> consultoresCollection) {
        this.consultoresCollection = consultoresCollection;
    }

//    @Override
//    public int hashCode() {
//        int hash = 0;
//        hash += (ubicacionCodigo != null ? ubicacionCodigo.hashCode() : 0);
//        return hash;
//    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Ubicacion)) {
            return false;
        }
        Ubicacion other = (Ubicacion) object;
        if ((this.ubicacionCodigo == null && other.ubicacionCodigo != null) || (this.ubicacionCodigo != null && !this.ubicacionCodigo.equals(other.ubicacionCodigo))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.cosmodas.dbcon.Ubicacion[ ubicacionCodigo=" + ubicacionCodigo + " ]";
    }

}
